﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
'Custom View class
'Events declarations
#Event: Click


'Designer property declarations
#DesignerProperty: Key: Text, DisplayName: Text, FieldType: String, DefaultValue: Text, Description: Text at the bottom of the button.
#DesignerProperty: Key: TextAlignment, DisplayName: TextAlignment, FieldType: String, DefaultValue: CENTER, Description: 文字位置
#DesignerProperty: Key: BackgroundColor, DisplayName: BackgroundColor, FieldType: Color, DefaultValue: 0xFFDADADA , Description: Background color.
#DesignerProperty: Key: PressedColor, DisplayName: PressedColor, FieldType: Color, DefaultValue: 0xFFFFFF00, Description: Color when the button is pressed.
#DesignerProperty: Key: BorderWidth, DisplayName:BorderWidth, FieldType: Int, DefaultValue: 1 , Description: Border Width
#DesignerProperty: Key: BorderColor, DisplayName:BorderColor, FieldType: Color, DefaultValue: 0xFF000000, Description: Border Color
#DesignerProperty: Key: ButtonType, DisplayName: ButtonType, FieldType: String, DefaultValue: STANDARD, List: STANDARD|TOGGLE, Description: Select the buttton type.


Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private mParent As Pane
	Private mLabel As Label
	
	Private  mTag As Object		'不懂為何宣告物件???
	
	Private mLeft, mTop, mWidth, mHeight As Int
	
	Private mText As String
	Private mTextColor As Paint
	'Private mLabelTextSize As Double
	Private mTextAlignment As String
	
	Private mPressedColor, mBackgroundColor ,mBorderColor  As Paint
	Private mBorderWidth  As Int
	Private mLeft, mTop, mWidth, mHeight As Int
	
	
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	Log("========================>")
	Log("jxyzButton  Initialize ==>")
	Log("EventName= "&EventName)
	
	mEventName = EventName
	mCallBack = Callback
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	Log("jxyzButton DesignerCreateView==>")
	Log("TextAlignment= "&Props.Get("TextAlignment"))

	Log("Text="&Props.Get("Text"))
	
	'Base.RemoveAllNodes 
	'Base.Visible = False	'基本上 只需要它的參數
	'Base.RemoveView	'B4A

	Try
		mParent = Base.Parent		
		
		mLeft = Base.Left
		mTop = Base.Top
		mWidth = Base.Width
		mHeight = Base.Height
				
		mText = Props.Get("Text")
		mTextColor = Lbl.TextColor
		mTextAlignment = Props.Get("TextAlignment")
		mBackgroundColor = Props.Get("BackgroundColor")
		mPressedColor = Props.Get("PressedColor")
		mBorderWidth = Props.Get("BorderWidth")
		mBorderColor = Props.Get("BorderColor")
		
		mTag = Base.Tag

		'mBase = Base 
		
		mBase.Initialize("mBase")
		mParent.AddNode(mBase, mLeft, mTop, mWidth, mHeight)
		
		'
		CSSUtils.SetBackgroundColor(mBase , mBackgroundColor  )	'設定背景顏色
		CSSUtils.SetBorder(mBase , mBorderWidth ,mBorderColor,0)
	Catch
		Log(LastException)
	End Try
	
	'InitClass		'mLabel產生 .擺在這邊..文字位置顯示 會沒作用
End Sub


Public Sub AddToParent(Parent As Pane,  Props As Map)
	Log("jxyzButton  AddToParent ==>")
	Log("TextAlignment= "&Props.Get("TextAlignment"))
	
	mParent = Parent
	
	mLeft = Props.Get("Left")
	mTop = Props.Get("Top")
	mWidth = Props.Get("Width")
	mHeight = Props.Get("Height")

	mText = Props.Get("Text")
	mTextColor = Props.Get("TextColor")
	mTextAlignment = Props.Get("TextAlignment")
	mBackgroundColor = Props.Get("BackgroundColor")
	mPressedColor = Props.Get("PressedColor")
	mBorderWidth = Props.Get("BorderWidth")
	mBorderColor = Props.Get("BorderColor")
	mTag = Props.Get("Tag")
	
	mBase.Initialize("mBase")
	mParent.AddNode(mBase, mLeft, mTop, mWidth, mHeight)
	'
	CSSUtils.SetBackgroundColor(mBase , mBackgroundColor  )	'設定背景顏色
	CSSUtils.SetBorder(mBase , mBorderWidth ,mBorderColor,0)
	'
	InitClass
End Sub

Private Sub InitClass
	Log("jxyzButton  InitClass ==>")
	
	
	'initialize and add the text Label
	mLabel.Initialize("")
				
	mLabel.Text = mText															 
	mLabel.TextSize = 28																		'B4J, B4A
	mLabel.TextColor = mTextColor
	mLabel.Alignment = mTextAlignment
	'mLabel.Alignment = "CENTER"	
															 
	mBase.AddNode(mLabel, 0, 0, mWidth, mHeight)	'B4J
	'mLabel.Left = 0	
End Sub



'Base_Resize 手冊上有講.說這邊要加入寬高
Private Sub Base_Resize (Width As Double, Height As Double)
	Log("jxyzButton  Base_Resize ==>")
	
	mWidth = Width
	mHeight = Height
	mBase.PrefWidth = mWidth
	mBase.PrefHeight = mHeight
	
	Log("手冊上有講.說這邊要加入InitClass")
	InitClass	'Base_Resize 手冊上有講.說這邊要加入
End Sub

Private Sub mBase_Touch (Action As Int, X As Double, Y As Double)
	Log("jxyzButton  mBase_Touch==>")
	Log( Action)
	
	Select Action
		Case 0	' ACTION_DOWN

			CSSUtils.SetBackgroundColor(mBase , mPressedColor  )	'設定背景顏色
		Case 2	' ACTION_MOVE

		Case 1	' ACTION_UP
			If SubExists(mCallBack, mEventName & "_Click") = True Then
				CallSub(mCallBack,  mEventName & "_Click")
		
			End If

			CSSUtils.SetBackgroundColor(mBase , mBackgroundColor  )	'設定背景顏色
	End Select

End Sub

'Private Sub mBase_MousePressed (EventData As MouseEvent)
'	Log("jxyzButtonN  mBase_MousePressed==>")
'	
'	CSSUtils.SetBackgroundColor(mBase , mPressedColor  )	'設定背景顏色
'End Sub
'Private Sub mBase_MouseReleased (EventData As MouseEvent)
'	Log("jxyzButtonN  mBase_MouseReleased==>")
'	 
'	
'	If SubExists(mCallBack, mEventName & "_Click") = True Then
'		CallSub(mCallBack,  mEventName & "_Click")
'		
'		CSSUtils.SetBackgroundColor(mBase , mBackgroundColor  )	'設定背景顏色
'	End If
'End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub

'get or set the Tag property
Public Sub setTag(Tag As Object)
	mTag = Tag
	mBase.Tag = Tag
End Sub

Public Sub getTag As Object
	Return mTag
End Sub


Public Sub setPressedColor(PressedColor  As Paint)
	mPressedColor = PressedColor
End Sub

Public Sub getPressedColor  As Paint
	Return mPressedColor
End Sub

Public Sub setTextAlignment(s1  As String)
	 mTextAlignment = s1
End Sub


Public Sub getTextAlignment  As String
	Return mTextAlignment
End Sub

Public Sub ss1
	
End Sub

