﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
'Custom View class
'Events declarations
#Event: Click


'Designer property declarations
#DesignerProperty: Key: Text, DisplayName: Text, FieldType: String, DefaultValue: Text, Description: Text at the bottom of the button.
#DesignerProperty: Key: TextAlignment, DisplayName: TextAlignment, FieldType: String, DefaultValue: CENTER, Description: 文字位置
#DesignerProperty: Key: BackgroundColor, DisplayName: BackgroundColor, FieldType: Color, DefaultValue: 0xFFDADADA , Description: Background color.
#DesignerProperty: Key: PressedColor, DisplayName: PressedColor, FieldType: Color, DefaultValue: 0xFFFFFF00, Description: Color when the button is pressed.
#DesignerProperty: Key: BorderWidth, DisplayName:BorderWidth, FieldType: Int, DefaultValue: 1 , Description: Border Width
#DesignerProperty: Key: BorderColor, DisplayName:BorderColor, FieldType: Color, DefaultValue: 0xFF000000, Description: Border Color
#DesignerProperty: Key: ButtonType, DisplayName: ButtonType, FieldType: String, DefaultValue: STANDARD, List: STANDARD|TOGGLE, Description: Select the buttton type.


Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private mParent As Pane
	Private mButton As Button
	
	Private  mTag As Object		'不懂為何宣告物件???
	
	Private mLeft, mTop, mWidth, mHeight As Int
	
	Private mText As String
	Private mTextColor As Paint
	'Private mLabelTextSize As Double
	Private mTextAlignment As String
	
	Private mPressedColor, mBackgroundColor ,mBorderColor  As Paint
	Private mBorderWidth  As Int
	Private mLeft, mTop, mWidth, mHeight As Int
	
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	Log("========================>")
	Log("jxyzButtonN  Initialize ==>")
	Log("EventName= "&EventName)
	
	mEventName = EventName
	mCallBack = Callback
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	Log("jxyzButtonN DesignerCreateView==>")
	Log("TextAlignment= "&Props.Get("TextAlignment"))

	Log("Text="&Props.Get("Text"))
	
	'Base.RemoveAllNodes
	'Base.Visible = False	'基本上 只需要它的參數
	'Base.RemoveView	'B4A

	Try
		mParent = Base.Parent
		
		mLeft = Base.Left
		mTop = Base.Top
		mWidth = Base.Width
		mHeight = Base.Height
				
		mText = Props.Get("Text")
		mTextColor = Lbl.TextColor
		mTextAlignment = Props.Get("TextAlignment")
		mBackgroundColor = Props.Get("BackgroundColor")
		mPressedColor = Props.Get("PressedColor")
		mBorderWidth = Props.Get("BorderWidth")
		mBorderColor = Props.Get("BorderColor")
		
		mTag = Base.Tag

		'mBase = Base
		
		mBase.Initialize("mBase")
		mParent.AddNode(mBase, mLeft, mTop, mWidth, mHeight)
		
		'
'		CSSUtils.SetBackgroundColor(mBase , mBackgroundColor  )	'設定背景顏色
'		CSSUtils.SetBorder(mBase , mBorderWidth ,mBorderColor,0)
	Catch
		Log(LastException)
	End Try
	
End Sub


Public Sub AddToParent(Parent As Pane,  Props As Map)
	Log("jxyzButtonN  AddToParent ==>")
	Log("TextAlignment= "&Props.Get("TextAlignment"))
	
	mParent = Parent
	
	mLeft = Props.Get("Left")
	mTop = Props.Get("Top")
	mWidth = Props.Get("Width")
	mHeight = Props.Get("Height")

	mText = Props.Get("Text")
	mTextColor = Props.Get("TextColor")
	mTextAlignment = Props.Get("TextAlignment")
	mBackgroundColor = Props.Get("BackgroundColor")
	mPressedColor = Props.Get("PressedColor")
	mBorderWidth = Props.Get("BorderWidth")
	mBorderColor = Props.Get("BorderColor")
	mTag = Props.Get("Tag")
	
	mBase.Initialize("mBase")
	mParent.AddNode(mBase, mLeft, mTop, mWidth, mHeight)
	'
'	CSSUtils.SetBackgroundColor(mBase , mBackgroundColor  )	'設定背景顏色
'	CSSUtils.SetBorder(mBase , mBorderWidth ,mBorderColor,0)
	'
	InitClass
End Sub

Private Sub InitClass
	Log("jxyzButtonN  InitClass ==>")
	
	
	'initialize and add the text Label
	mButton.Initialize("mButton")
				
	mButton.Text = mText
	mButton.TextSize = 28																		'B4J, B4A
	mButton.TextColor = mTextColor
	mButton.Alignment = mTextAlignment
	'mButton.Alignment = "CENTER"
															 
	mBase.AddNode(mButton, 0, 0, mWidth, mHeight)	'B4J
	'mButton.Left = 0
	CSSUtils.SetBackgroundColor(mButton , mBackgroundColor  )	'設定背景顏色
	CSSUtils.SetBorder(mButton , mBorderWidth ,mBorderColor,0)
	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	Log("jxyzButtonN  Base_Resize ==>")
	
	mWidth = Width
	mHeight = Height
	mBase.PrefWidth = mWidth
	mBase.PrefHeight = mHeight
	
	Log("手冊上有講.說這邊要加入InitClass")
	InitClass	'Base_Resize 手冊上有講.說這邊要加入
End Sub

 'jxyzButtonN 偵測不到Base_Touch
Private Sub Base_Touch (Action As Int, X As Double, Y As Double)
	Log("jxyzButtonN  Base_Touch==>")
	Log( Action)
	
 

End Sub

'jxyzButtonN 偵測不到Base_Touch
Private Sub mBase_Touch (Action As Int, X As Double, Y As Double)
	Log("jxyzButtonN  mBase_Touch==>")
	Log( Action)
	
	Select Action
		Case 0	' ACTION_DOWN

			CSSUtils.SetBackgroundColor(mButton , mPressedColor  )	'設定背景顏色
		Case 2	' ACTION_MOVE

		Case 1	' ACTION_UP
			If SubExists(mCallBack, mEventName & "_Click") = True Then
				CallSub(mCallBack,  mEventName & "_Click")
		
			End If

			CSSUtils.SetBackgroundColor(mButton , mBackgroundColor  )	'設定背景顏色
	End Select

End Sub


Private Sub mButton_Click
	Log("jxyzButtonN  mButton_Click==>")
	'Log( Action)
	If SubExists(mCallBack, mEventName & "_Click") = True Then
		CallSub(mCallBack,  mEventName & "_Click")
		
	End If
		
	'

End Sub


Private Sub mButton_MousePressed (EventData As MouseEvent)
	Log("jxyzButtonN  mButton_MousePressed==>")
	
	CSSUtils.SetBackgroundColor(mButton , mPressedColor  )	'設定背景顏色
End Sub
Private Sub mButton_MouseReleased (EventData As MouseEvent)
	Log("jxyzButtonN  mButton_MouseReleased==>")
	 
	
	If SubExists(mCallBack, mEventName & "_Click") = True Then
		CallSub(mCallBack,  mEventName & "_Click")
		
		CSSUtils.SetBackgroundColor(mButton , mBackgroundColor  )	'設定背景顏色
	End If
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub

'get or set the Tag property
Public Sub setTag(Tag As Object)
	mTag = Tag
	mBase.Tag = Tag
End Sub

Public Sub getTag As Object
	Return mTag
End Sub


Public Sub setPressedColor(PressedColor  As Paint)
	mPressedColor = PressedColor
End Sub

Public Sub getPressedColor  As Paint
	Return mPressedColor
End Sub

Public Sub setTextAlignment(s1  As String)
	 mTextAlignment = s1
End Sub


Public Sub getTextAlignment  As String
	Return mTextAlignment
End Sub

Public Sub ss1
	
End Sub

