﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
'
'Events declarations
'#Event: Click
'#Event: LongClick
'#Event: CheckdChange(Checked As Boolean)
'#RaisesSynchronousEvents: Click
'#RaisesSynchronousEvents: LongClick
'#RaisesSynchronousEvents: CheckdChange

'CustomView屬性(視覺設計)
#DesignerProperty: Key: Text, DisplayName: Text, FieldType: String, DefaultValue: Text, Description: 要顯示的文字
#DesignerProperty: Key: TextSize, DisplayName: TextSize, FieldType: Int, DefaultValue: 18, Description: 顯示的文字大小
#DesignerProperty: Key: BackgroundColor, DisplayName: BackgroundColor, FieldType: Color, DefaultValue: 0xFFDADADA , Description: Background color.
#DesignerProperty: Key: PressedColor, DisplayName: PressedColor, FieldType: Color, DefaultValue: 0xFFFFFF00, Description: Color when the button is pressed.
#DesignerProperty: Key: BorderWidth, DisplayName:BorderWidth, FieldType: Int, DefaultValue: 1 , Description: Border Width
#DesignerProperty: Key: BorderColor, DisplayName:BorderColor, FieldType: Color, DefaultValue: 0xFF000000, Description: Border Color
#DesignerProperty: Key: ButtonType, DisplayName: ButtonType, FieldType: String, DefaultValue: STANDARD, List: STANDARD|TOGGLE, Description: Select the buttton type.

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	
	Private xui As XUI 'ignore
	
	Private b4xTemp As B4XView
	Private b4xBase As B4XView
	Private b4xParent As B4XView
	Private b4xLabel As B4XView
	
	Private mLabel As Label

	Private mTag As Object		'不懂為何宣告物件???
 
	Private mText As String
	Private mTextColor As Int
	Private mTextSize As Double
	
	Private mBackgroundColor As Int
	'Private mPressedColor, mBackgroundColor As Int
	Private mBorderWidth ,mBorderColor As Int
	Private mLeft, mTop, mWidth, mHeight As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	Log("========================>")
	Log("xyzLabel  Initialize ==>")
	Log("EventName= "&EventName)
	
	mEventName = EventName
	mCallBack = Callback
	
	mText = ""
	'mTextSize = 24
	mTextColor = xui.Color_Cyan
	'mColor = xui.Color_White
	'mEnabled = True
 
	
	'mPressedColor = xui.Color_Yellow
	'mButtonType = "STANDARD"
	mBackgroundColor = xui.Color_Transparent
	'mOnStateColor = xui.Color_Blue
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	Log("xyzLabel DesignerCreateView==>")
	
	Log("test1")
	Log("Text="&Props.Get("Text"))

	'DesignerCreateView下,Base為基礎
	b4xTemp = Base				'照論壇上的範例.Base當作暫時的物件
	'xui.Color_Transparent		'穿透屬性顏色.跟底面顏色依樣
	'b4xTemp.SetColorAndBorder(mBackgroundColor ,  mBorderWidth , mBorderColor , 0dip )
	b4xTemp.Visible = False		'我把它隱藏起來.安心
	
	mLeft = b4xTemp.Left
	mTop = b4xTemp.Top
	mWidth = b4xTemp.Width
	mHeight = b4xTemp.Height
	mTag = b4xTemp.Tag				'利用原有的屬性.不須另外設定
	'
	Try
		mText = Props.Get("Text")
		mTextColor = xui.PaintOrColorToColor(Lbl.TextColor)
		'mPressedColor = xui.PaintOrColorToColor(Props.Get("PressedColor"))
		mBackgroundColor = xui.PaintOrColorToColor(Props.Get("BackgroundColor"))
		mBorderWidth = Props.Get("BorderWidth")
		mBorderColor = xui.PaintOrColorToColor(Props.Get("BorderColor"))
		
	Catch
		Log("xyzLabel DesignerCreateView= "&LastException)
	End Try
	
	'
	b4xBase = xui.CreatePanel("b4xBase")	'這個是手動建立一個Panel物件,b4xBase名稱為前綴事件
	b4xBase.SetColorAndBorder(mBackgroundColor ,  mBorderWidth , mBorderColor , 0dip )
	'b4xBase.Visible = True
	
	
	b4xParent = b4xTemp.Parent
	b4xParent.AddView(b4xBase, mLeft, mTop, mWidth, mHeight)
	'b4xBase.BringToFront
	

	InitClass	'在b4xBase基礎上建一個B4xLabel物件
End Sub


'非視覺設計模式.需引用
Public Sub AddToParent(Parent As Object,  Props As Map)
	Log("xyzLabel  AddToParent ==>")
	
	'將參數存入變數
	b4xParent = Parent

	Try	'傳入的參數.有可能出錯???
		mLeft = Props.Get("Left")
		mTop = Props.Get("Top")
		mWidth = Props.Get("Width")
		mHeight = Props.Get("Height")
		
		mText = Props.Get("Text")
		mTextColor = xui.PaintOrColorToColor(Props.Get("TextColor"))
		mTag = Props.Get("Tag")
		'mPressedColor = xui.PaintOrColorToColor(Props.Get("PressedColor"))
		mBackgroundColor = xui.PaintOrColorToColor(Props.Get("BackgroundColor"))
		mBorderWidth = Props.Get("BorderWidth")
		mBorderColor = xui.PaintOrColorToColor(Props.Get("BorderColor"))
		
	Catch
		Log("xyzLabel AddToParent= "&LastException)
	End Try
	

	b4xBase = xui.CreatePanel("b4xBase")	'這個是手動建立一個Panel物件,b4xBase名稱為前綴事件

	b4xParent.AddView(b4xBase, mLeft, mTop, mWidth, mHeight)
	b4xBase.SetColorAndBorder(mBackgroundColor ,  mBorderWidth , mBorderColor , 0dip )
	
	
	InitClass	'在b4xBase基礎上建一個B4xLabel物件
End Sub

Private Sub InitClass
	Log("xyzLabel  InitClass ==>")
	
	'calculate the dimensions of the internal Labels
	Private  lblWidth  As Int
	lblWidth = 2 * mHeight / 3		'icon Label width and height = 2/3 of button height
	'lblLeft = (mWidth - lblWidth) / 2

	mTextSize = lblWidth / 3 / xui.Scale
	
	'initialize and add the text Label
	mLabel.Initialize("")
	b4xLabel = mLabel
	b4xLabel.SetTextAlignment("CENTER", "CENTER")
	'b4xLabel.Font = b4xLabelFont
	b4xLabel.TextSize = mTextSize
	b4xLabel.TextColor = xui.PaintOrColorToColor(mTextColor)
	'PaintOrColorToColor (Color As Object) As Int
	'B4A, B4i - Does nothing.
	'B4J - Converts a Paint object To an Int color. Does Not Do anything If the color Is already an Int color.
	b4xLabel.Text = mText
	'b4xLabel.Visible = False
'	'b4xLabel.SetColorAndBorder(mBackgroundColor , 10dip , mBorderColor , 3dip )	
	
	b4xBase.AddView(b4xLabel, 0, 0 ,b4xBase.Width  ,b4xBase.Height )


End Sub


Private Sub Base_Resize (Width As Double, Height As Double)
	Log("xyzLabel  Base_Resize ==>")
	Log("xyzLabel  Width= "&Width)
	'mWidth = Width
	'mHeight = Height
  
	b4xLabel.Width = Width
	b4xLabel.Height = Height
	
	'InitClass
End Sub



Private Sub b4xBase_Touch (Action As Int, X As Double, Y As Double)
	Log("xyzLabel  b4xBase_Touch==>")
	Log( Action)
	
	If b4xBase.TOUCH_ACTION_UP == Action Then
		If SubExists(mCallBack, mEventName & "_Click") = True Then
			CallSub(mCallBack, mEventName & "_Click")
		End If
	End If
 

End Sub


'get or set the Tag property
Public Sub setTag(Tag As Object)
	mTag = Tag
	b4xBase.Tag = Tag
End Sub

Public Sub getTag As Object
	Return mTag
End Sub

Public Sub setText(s1 As String)
	Log("setText ==>")
	'If s1.Length > 0 Then
		
		mText=s1
		b4xLabel.Text = s1
	'End If
	
End Sub

Public Sub getText  As String
	Return mText
End Sub


Public Sub setTextSize(s1 As Int)
	Log("setTextSize ==>")
		
	mTextSize=s1
	b4xLabel.TextSize = s1
End Sub

Public Sub getTextSize  As Int
	Return mTextSize
End Sub


Public Sub setTextColor(s1 As Int)
	Log("setTextColor ==>")
		
	mTextColor=s1
	b4xLabel.TextColor = mTextColor
End Sub

Public Sub setBackgroundColor(s1 As Int)
	Log("setBackgroundColor ==>")
		
	mBackgroundColor=s1
	If b4xBase.IsInitialized Then b4xBase.Color = mBackgroundColor
End Sub
Public Sub getBackgroundColor  As Int
	Return mBackgroundColor
End Sub


'文字顯示的位置
Public Sub SetTextAlignment(s1 As String,s2 As String)

	b4xLabel.SetTextAlignment(s1 , s2 )
End Sub



